package xtime

import "github.com/golang-module/carbon/v2"

const (
	WeekLayout    = "Y-W"
	MonthLayout   = "Y-m"
	QuarterLayout = "Y-Q"
	YearLayout    = "Y"
)

// 2006-01-02

func FormatDate(c carbon.Carbon) string {
	return c.ToDateString()
}

// 2006-55 (55周)

func FormatWeek(c carbon.Carbon) string {
	return c.Format(WeekLayout)
}

// 2006-12

func FormatMonth(c carbon.Carbon) string {
	return c.Format(MonthLayout)
}

// 2006-04 (4季度)

func FormatQuarter(c carbon.Carbon) string {
	return c.Format(QuarterLayout)
}

// 2006

func FormatYear(c carbon.Carbon) string {
	return c.Format(YearLayout)
}

// 20060102

func FormatDateNum(c carbon.Carbon) int {
	return c.Year()*10000 + c.Month()*100 + c.Day()
}
